#
# Sensus Consulting Ltd (C) 1998
# Matt Newman <matt@sensus.org>
#
# ensemble - ala [incr Tcl]
#
#INDEX\
proc ensemble {} {}

package require tcl++ 2.0

namespace eval tcl++ {
	namespace export ensemble

	namespace eval ensemble {
		variable _options
	}
	namespace eval ensemble-parser {
		variable _ns_

		namespace export ensemble parse

		proc option {name argv body} {
			::variable _ns_
			upvar ${_ns_}::_options options

			set options($name) ${_ns_}::$name

			proc ${_ns_}::$name $argv $body
		}
		proc ensemble {name body} {
			::variable _ns_
			upvar ${_ns_}::_options options

			set options($name) ${_ns_}::$name

			proc ${_ns_}::$name {option args} [format {
				upvar %s::_options options
				set opt [array names options ${option}*]
				if {[llength $opt]==1} {
					return [uplevel 1 $options($opt) $args]
				} elseif {[llength $opt]>1} {
					set opts [lsort [array names options ${option}*]]
					set opts [lreplace $opts end end "or [lindex $opts end]"]
					error "ambiguous option \"$option\": must be one of [join $opts ", "]"
				}
				if {[info exists options(@error)]} {
					return [uplevel 1 $options(@error) $option $args]
				} else {
					set opts [lsort [array names options]]
					set opts [lreplace $opts end end "or [lindex $opts end]"]
					error "bad option \"$option\": must be one of [join $opts ", "]"
				}
			} ${_ns_}::$name]
			# parse nested-ensemble
			set _ns_ [tcl++::jns $_ns_ $name]
			namespace eval ${_ns_} {variable _options}
			namespace eval ::tcl++::ensemble-parser $body
			set _ns_ [namespace parent $_ns_]
		}
	}
}
proc tcl++::ensemble {name body} {
	set ns [uplevel 1 namespace current]
	set name [fqns $ns $name]
	set ns [namespace qualifiers $name]
	set name [namespace tail $name]
	if {$ns == ""} {set ns ::}
	#
	# Initialize nested stack
	set ensemble-parser::_ns_ [jns ::tcl++::ensemble $ns]
	#
	# Initialize namespace for ensemble commands
	namespace eval ${ensemble-parser::_ns_} [list namespace export $name]
	#
	# Kick off the recursive parser
	ensemble-parser::ensemble $name $body
	#
	# Import into parent namespace
	namespace eval $ns [list namespace import -force [jns ${ensemble-parser::_ns_} $name]]
}
namespace import -force tcl++::ensemble
