#
# Sensus Consulting Ltd (C) 1997
# Matt Newman <matt@sensus.org>
#
# Base Class for lightweight canvas compound objects
#
#INDEX\
proc tk++::Canvas::ImgLabel {} {}

package require tk++

proc cimglabel {args} {return [eval tk++::Canvas::ImgLabel $args]}

class tk++::Canvas::ImgLabel {
	inherit tk++::Canvas::Label

	constructor {args} {eval configure $args}

	public method coords {tag args} {}
	public method create {type x y args} {}

	protected method refresh {tag} {}
}
body tk++::Canvas::ImgLabel::create {type x y args} {
	array set opts {
		-image		{}
		-iwidth		0
		-iheight	0
		-ipadx		3
	}
	array set opts $args

	set tag [chain $type $x $y]
	set tags($tag,image) [$canvas create image 0 0 -tags $tag]

	eval itemconfigure $tag [array get opts]

	return $tag
}
body tk++::Canvas::ImgLabel::refresh {tag x y} {
	if {![info exists tags($tag,image)]} {
		# Must be during construction
		return
	}
	set iwidth	[pget $items($tag) -iwidth]
	set iheight	[pget $items($tag) -iheight]
	set ipadx	[pget $items($tag) -ipadx]
	set image	[pget $items($tag) -image]
	if {$iwidth == 0} {
		# Auto-size
		set iwidth [image width $image]
	}
	if {$iheight == 0} {
		# Auto-size
		set iheight [image height $image]
	}
	$canvas itemconfigure $tags($tag,image) -image $image -anchor c
	$canvas coords $tags($tag,image) \
					[expr {$x + $iwidth/2.0}] [expr {$y + $iheight/2.0}]

	chain $tag [expr {$x + $iwidth + $ipadx}] $y
}
